LSH512_256 Class Reference

LSH-512-256 hash function. More...

`#include <lsh.h>`

Inheritance diagram for LSH512_256:

## Public Member Functions

| LSH512_256 ()
| Construct a LSH-512-256.
std::string | AlgorithmName () const
| Provides the name of this algorithm.
Public Member Functions inherited from LSH512_Base
unsigned int | BlockSize () const
| Provides the block size of the compression function.
unsigned int | DigestSize () const
| Provides the digest size of the hash.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
void | Restart ()
| Restart the hash.
void | Update (const byte *input, size_t size)
| Updates a hash with additional input.
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message.
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Static Public Member Functions

static std::string | StaticAlgorithmName ()
| The algorithm's name.

## Static Public Attributes

static const int | DIGESTSIZE = 32
| Digest size, in bytes.
static const int | BLOCKSIZE = LSH512_Base::BLOCKSIZE
| Block size, in bytes.
Static Public Attributes inherited from LSH512_Base
static const int | BLOCKSIZE = 256
| Block size, in bytes.

## Detailed Description

LSH-512-256 hash function.

See also
  LSH on the Korea Internet & Security Agency (KISA) website.

Since
  Crypto++ 8.6

Definition at line 235 of file lsh.h.

## Constructor & Destructor Documentation

## LSH512_256()

LSH512_256::LSH512_256 | ( |  | ) |

inline

Construct a LSH-512-256.

LSH_TYPE_512_256 is the magic value 0x0010020 defined in lsh.cpp.

Definition at line 255 of file lsh.h.

## Member Function Documentation

## StaticAlgorithmName()

static std::string LSH512_256::StaticAlgorithmName | ( |  | ) |

inline static

The algorithm's name.

Returns
  the standard algorithm name

The standard algorithm name can be a name like `AES` or `AES/GCM`. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  StaticAlgorithmName is not universally implemented yet.

Definition at line 251 of file lsh.h.

## AlgorithmName()

std::string LSH512_256::AlgorithmName | ( |  | ) | const

inline virtual

Provides the name of this algorithm.

Returns
  the standard algorithm name

The standard algorithm name can be a name like `AES` or `AES/GCM`. Some algorithms do not have standard names yet. For example, there is no standard algorithm name for Shoup's ECIES.

Note
  AlgorithmName is not universally implemented yet.

Reimplemented from Algorithm.

Definition at line 257 of file lsh.h.

## Member Data Documentation

## DIGESTSIZE

const int LSH512_256::DIGESTSIZE = 32

static

Digest size, in bytes.

LSH_512 uses LSH_GET_HASHBYTE(algType) for digest size, which is 32

Definition at line 240 of file lsh.h.

## BLOCKSIZE

const int LSH512_256::BLOCKSIZE = LSH512_Base::BLOCKSIZE

static

Block size, in bytes.

LSH_512 uses LSH512_MSG_BLK_BYTE_LEN for block size, which is 256

Definition at line 243 of file lsh.h.

The documentation for this class was generated from the following file:

- lsh.h